{
 Демонстрация датчика гироскопа (sns4.pp)
 При старте программы робот должен находиться в состоянии покоя.
 Калибровкой датчика гироскопа фиксируется первоначальное
 направление робота.
 Если направление робота изменяется (например - ручным перемещением
 в другое положение), то выждав 5-секундний 
 интервал, робот плавно возвращается в исходное положение
 с помощью вращения вокруг своей оси. 

 Требования:
 Два больших мотора, левый подключен к
 порту с меньшим номером, правый - к порту
 с большим номером.
 Датчик гироскопа, подключен к любому порту.

}
{$mode objfpc}
uses sysutils,dateutils,uev3,uev3Devices,rubiroSensors,rubiroMotors,math;
 var Rule:TEv3Rule;
     gyr:TEv3GyroSensor;
     dt:TDateTime;
     angle:integer;
begin
  ev3Init();
  Rule:=Tev3Rule.create();
  gyr:=TEv3GyroSensor.create();
  gyr.calibrate;
  dt:=now();
  while true do begin
    angle:=gyr.angle;
    if (angle>-10)and(angle<10) then begin
     Rule.Stop();
     dt:=now();
    end else begin
     if MilliSecondsBetween(now(),dt)<5000 then continue;
     Rule.Run(-100*sign(angle),10+sqrt(abs(angle)));
    end;
  end;
end.

